<template>
    <div class="main-content__div">
      <div class="table-box__div" v-cloak v-loading="loadingFlag">
        <el-form  class="demo-form-inline">
          <el-form-item label="广告名称">
            <el-input
              placeholder="广告名称"
              v-model="keyword"
              style="width:150px;"
              size="small"
              >
            </el-input>
          </el-form-item>
          
          <!-- 搜索按钮 -->
          <el-form-item>
            <el-button type="primary" size="small" @click="searchFrom()">搜索</el-button>
          </el-form-item>
        </el-form>
      </div>
      <!-- 列表 -->
      <div class="table-box__div" v-cloak v-loading="loadingFlag">
        <el-table
          size="mini"
          :data="tableData"
          :empty-text="tableDataLoadingText"
          style="width: 100%;font-size: 15px;"
          :header-cell-style="{background:'#FAFAFA'}"
        >
          <el-table-column label="编号" width="100" prop="id"></el-table-column>
          <el-table-column label="广告类型" prop="type_name" width="100"></el-table-column>
          <el-table-column label="广告位名称" prop="place_name" width="200"></el-table-column>
          <el-table-column label="广告名称" prop="name" width="250"></el-table-column>
          <el-table-column label="状态" prop="runing_name" width="100"></el-table-column>
          <el-table-column label="审核" prop="status_name" width="100"></el-table-column>
          <el-table-column label="开始时间" prop="fromtime" width="200"></el-table-column>
          <el-table-column label="结束时间" prop="totime" width="200"></el-table-column>
          <el-table-column label="剩余(天)" prop="day" width="100"></el-table-column>
          <el-table-column   prop="" label="操作" align="center"  fixed="right" width="200">
                  <template v-slot="scope">
                    <div style="display: flex;flex-direction: row;justify-content: center;align-items: center;">
                      <span class="btn"  @click="updateClick(scope.row, scope.$index)">编辑</span>
                      <span class="btn"  @click="deleteAuthority(scope.row,scope.$index)">删除</span>
                    </div>
                  </template>
                </el-table-column>
        </el-table>
        <!-- 分页 -->
        <div class="block" v-show="pagination" style="margin-top: 10px;float: right;">
          <el-pagination
            background
            @current-change="handleCurrentChange"
            :current-page="currentPage"
            :page-size="pageSize"
            layout="total, prev, pager, next, jumper"
            :total="parseInt(tableCount)">
          </el-pagination>
        </div>
      </div>
    </div>
  <Dialog title="温馨提示" content="您确认要删除该广告吗？"
          @close="DialogShow = false"
          @submitSureClick="submitSureClickDel"
          @DialogFalse="DialogShow = false"
          :innerVisible="DialogShow">
  </Dialog>
  <DialogSlot
      title="添加/编辑"
      @close="AdDialogShow = false"
      @DialogClose="AdDialogShow = false"
      :innerVisible="AdDialogShow"
      @colesClick="AdDialogShow  = false"
  >
    <editFrom
        @colesClick="AdDialogShow = false"
        :AdDataForm="AdDataForm"
         :isloading="isloading"
        @AdSubmitClick="AdSubmitClick"
        @closeDlg="closeDlg"
        >
    </editFrom>
  </DialogSlot>
  </template>
  <script>
  import Dialog from "../../components/dialog";
  import editFrom from "./components/edit";
  import DialogSlot from "../../components/DialogSlot";
  export default {
    components: {
      Dialog,
      editFrom,
      DialogSlot
    },
    data() {
      return {
        value:"1",
        //  分类列表数据
        tableData: [],
        //  加载中数据提示
        tableDataLoadingText:"拼命加载中······",
        //  是否显示分页
        pagination:false,
        //  每页显示的条数
        pageSize:10,
        //  当前页
        currentPage:1,
        //  分类列表数据总条数
        tableCount:0,
  
        loadingFlag: false,
        isShowSource: false, // 是否显示来源列
        id:0,
        DialogShow: false, //控制删除弹窗
        AdId:'',
        AdRowIndex:'',
        AdDataForm: {},
        AdTableData: [],
        isloading:false, //提交按钮状态
        AdDialogShow: false, // 控制保存弹窗
        pid:0,
        keyword:''
      }
    },
    mounted() {
     
    },
    methods: {
      // 获取分类信息列表
      getList:function(){
        let _t = this;
        _t.loadingFlag = true;
        let parames = {
            'page':this.currentPage,
            'pageSize':this.pageSize,
            'keyWord':this.keyword
        }
        if(this.pid>0){
          parames.pid = this.pid
        }
        console.log("参数：",parames)
        this.$api.ad.getAdList(parames).then(res=>{
                _t.loadingFlag = false;
                if(res.code==200){
                  if(res.data.rows.length==0){
                    this.$message.error("还没有数据")
                    return
                  }
                    _t.tableData = res.data.rows;
                    _t.tableCount = res.data.count;
                     //总条数大于每页显示的条数时显示分页
                    if( _t.tableCount > _t.pageSize ){
                     _t.pagination = true;
                    }
                    if( _t.tableData.length==0 ){
                     _t.tableDataLoadingText = "暂无数据";
                    }
                }else{
                    this.$message.error(res.message)
                }
            })
      },
      // 点击翻页
      handleCurrentChange(val) {
        this.currentPage = val;
        this.getList();
      },
      // 查看下一级
      nextClick( id ){
        let _t = this;
        _t.id = id
        _t.currentPage = 1
        _t.pageSize = 10
       this.getList()
      },
      //更新分类
      updateClick(row,index){
        console.log(row)
        this.AdDataForm = row
        this.rowIndex = index
        this.AdDialogShow = true
      },
      // AdDialogShow(){
      //   this.isloading = false
      // },
      closeDlg(val){
          this.AdDialogShow = false
          this.isloading = false
      },
      AdSubmitClick(data){
        let _t = this
        console.log("提交数据",data)
        let parames = data
        _t.isloading = true
        //有id更新，没有新增
        if(parames.id){
          this.$api.ad.updateAd(parames).then(res=>{
                _t.loadingFlag = false;
                if(res.code==200){
                  _t.tableData[_t.rowIndex] = parames
                     console.log("修改成功")
                     this.getList()
                }else{
                    this.$message.error("修改失败")
                }
                this.AdDialogShow = false
                this.isloading = false
            })
        }else{
          this.$api.ad.createAd(parames).then(res=>{
                _t.loadingFlag = false;
                if(res.code==200){
                     console.log("创建成功")
                    this.getList()
                }else{
                    this.$message.error(res.message)
                }
                this.AdDialogShow = false
                this.isloading = false
            })
        }
       
      },
      //删除分类
      deleteAuthority(row, index) {
        this.AdId = row.id
        this.AdRowIndex = index
        this.DialogShow = true
      },
      searchFrom(){
        this.currentPage = 1
        this.pageSize = 10
        this.getList()
      },
      submitSureClickDel(row,index){
        let _t = this
        let parames = {
          'id':this.AdId
        }
        this.$api.ad.delAd(parames).then(res=>{
          if(res.code==200){
            this.DialogShow = false
            _t.tableData.splice(index, 1);
            // row.splice(index, 1);
            this.getList()
          }else{
            this.$message.error(res.message)
          }
        })
      }

    },
    created() {
        this.pid = this.$route.params.pid;
        this.getList();
    }
  }
  </script>
  
  <style >
  .demo-form-inline{
      display: flex;
  }
  .demo-form-inline .el-form-item{
    margin: 0 20px;
  }
  </style>